#pragma once

#include "MemoRecvAttachList.h"

#define DEF_MEMORECV_ATTACH_BG_COLOR			Color(255, 255, 255, 255)
#define DEF_MEMORECV_ATTACH_BGCENTERLINE_COLOR	Color(255, 239, 242, 243)
#define DEF_MEMORECV_ATTACH_BGOUTLINE_COLOR		Color(255, 203, 207, 216)

#define DEF_MEMORECV_ATTACH_FONT_NAME			(g_defaultFontFaceName)
#define DEF_MEMORECV_ATTACH_TITLE_FONT_HEIGHT	(9)
#define DEF_MEMORECV_ATTACH_TITLE_FONT_COLOR	Color(255, 34, 34, 34)
#define DEF_MEMORECV_ATTACH_TITLE_FONT_STYLE	(FontStyleBold)

#define DEF_MEMORECV_TITLE_POS_LEFT_X			(18)
#define DEF_MEMORECV_TITLE_POS_TOP_Y			(11)
#define DEF_MEMORECV_FILESAVE_POS_RIGHT_X		(18)
#define DEF_MEMORECV_FILESAVE_POS_TOP_Y			(8)
#define DEF_MEMORECV_FILELIST_POS_LEFT_X		(20)
#define DEF_MEMORECV_FILELIST_POS_TOP_Y			(35)
#define DEF_MEMORECV_FILELIST_EDIT_WIDTH		(230)

#define ID_MEMO_RECV_ATTACH_LIST				(0x6022)
#define ID_MEMO_RECV_SAVEALL_BTN				(0x6031)
#define ID_MEMO_RECV_SELECT_FOLDER				(0x6032)
#define ID_MEMO_RECV_SELECT_FOLDER_EDITBOX		(0x6023)
#define ID_MEMO_RECV_OPEN_FOLDER_CHECKBOX		(0x6024)

// CMemoRecvAttachWnd

typedef struct tagSELFOLDER_REQ_PARA
{
	CWnd		*pWnd;
	CString		strCurPath;
} SELFOLDER_REQ_PARA;

class CMemoRecvAttachWnd : public CWnd
{
	DECLARE_DYNAMIC(CMemoRecvAttachWnd)

public:
	CMemoRecvAttachWnd();
	virtual ~CMemoRecvAttachWnd();

	int							GetFileItemCount();
	CString						GetFileItemDownloadURL(int nIdx);
	void						AddFileItem(CString strPath, CString strName, ULONGLONG dwFileSize);
	CMemoRecvAttachList*		GetFileListCtrl() { return &m_listFileAttach; }
	void						SetFontConfig(WCHAR* wszFontName, REAL nFontHeight, FontStyle style, Color crText);
	void						SetImgBGPath(CString strFileName);
	void						SetTitle(CString strTitle);

private:
	// BG
	Image*						m_pImgBG;

	Color						m_crBG;
	Color						m_crOutline;
	HBRUSH						m_hBrushWhite;

	// font
	WCHAR						m_wszFontName[64];
	REAL						m_nFontHeight;
	FontStyle					m_fontStyle;
	Color						m_crText;

	REAL						m_nFontHeightTitle;
	Color						m_crTitle;
	FontStyle					m_fontStyleTitle;

	// dimension
	CRect						m_rtWnd;
	CRect						m_rtTitle;
	CSize						m_szTitle;
	CRect						m_rtFileList;

	CString						m_strTitle;

	// child
	CEdit						m_editDownloadFolderPath;
	CNMImgButton				m_btnFileSaveAll;
	CNMImgButton				m_btnSelectFolder;
	CMemoRecvAttachList			m_listFileAttach;
	CNMImgCheckButton			m_checkOpenFolder;	
	CRect						m_rtCheckOpenFolder;

	// select folder dialog is active
	bool						m_bSelFolderDlgIsActive;

protected:
	DECLARE_MESSAGE_MAP()

	void GetSaveAsPath(CString &folderName);

public:
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnPaint();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnBtnFileSaveAll();
	afx_msg void OnBtnSelectFolder();
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT	OnFolderSelected(WPARAM wParam,	LPARAM lParam);

	static int CALLBACK SHBrowseCallback(HWND hwnd, UINT uMsg, LPARAM lParam, LPARAM lpData);
	void __ResourceLoad(BOOL bInit = FALSE);
	void CheckFolderPath();
	void OnBtnCheckOpenFolder();
};
